unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Buttons, Grids, DBGrids, StdCtrls, ADODB, SMIBase, SMIWiz;

type
  TfrmMain = class(TForm)
    lblMDBName: TLabel;
    edMDBName: TEdit;
    btnMDBName: TButton;
    lblTableList: TLabel;
    cbTableList: TComboBox;
    DBGrid: TDBGrid;
    btnImport: TSpeedButton;
    dSrc: TDataSource;
    ADOConnection: TADOConnection;
    ADOTable: TADOTable;
    OpenDialog: TOpenDialog;
    SMIWizardDlg: TSMIWizardDlg;
    procedure edMDBNameExit(Sender: TObject);
    procedure ADOConnectionAfterConnect(Sender: TObject);
    procedure btnMDBNameClick(Sender: TObject);
    procedure cbTableListChange(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure ADOTableAfterOpen(DataSet: TDataSet);
    procedure ADOTableAfterClose(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.edMDBNameExit(Sender: TObject);
begin
  ADOConnection.Connected := False;
  ADOTable.Active := False;

  if (edMDBName.Text = '') then exit;

  ADOConnection.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Password="";Data Source=' + edMDBName.Text + ';Persist Security Info=True';
  ADOConnection.Connected := True;
end;

procedure TfrmMain.ADOConnectionAfterConnect(Sender: TObject);
begin
  {fill a list of tables}
  cbTableList.Items.BeginUpdate;
  try
    cbTableList.Items.Clear;
    ADOConnection.GetTableNames(cbTableList.Items, False);
    if (cbTableList.Items.Count > 0) then
    begin
      cbTableList.ItemIndex := 0;
      cbTableList.OnChange(cbTableList)
    end;
  finally
    cbTableList.Items.EndUpdate;
  end;
end;

procedure TfrmMain.btnMDBNameClick(Sender: TObject);
begin
  OpenDialog.FileName := edMDBName.Text;
  if OpenDialog.Execute then
  begin
    edMDBName.Text := OpenDialog.FileName;
    edMDBName.OnExit(edMDBName);
  end;
end;

procedure TfrmMain.cbTableListChange(Sender: TObject);
begin
  if (cbTableList.ItemIndex < 0) then exit;

  {re-fetch data from table}
  ADOTable.Close;
  ADOTable.TableName := cbTableList.Items[cbTableList.ItemIndex];
  ADOTable.Open;
end;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  SMIWizardDlg.Execute
end;

procedure TfrmMain.ADOTableAfterOpen(DataSet: TDataSet);
begin
  btnImport.Enabled := True
end;

procedure TfrmMain.ADOTableAfterClose(DataSet: TDataSet);
begin
  btnImport.Enabled := False
end;

end.
